function point = mosd (f, xarg, a, b)
  mosd_initialise();
  global mosd_numberimproved;
  if isempty(mosd_numberimproved), mosd_numberimproved = 0; end
  %% find the Jacobian at the current point
  nx = length(a);
  x = xarg(1:nx);
  y = f(x(1:nx));
  ny = length(y);
  J = zeros (ny, nx);
  h = 1e-6;
  for j=1:nx
    dx = x + h * eye(nx)(:,j);  % assumes x is column vector
    yj = f(dx);
    J(:,j) = (yj-y)/h;
  end
  %% now step along
  alpha = 1e-2 * (b-a);
  k = 0;
  dominates = 0;
  while k<15 && ~ dominates
    %% we try to move in different weighted directions
    lambda = 0.1;
    while lambda<1 && ! dominates
      newx = x - alpha .* (J' * [lambda; (1-lambda)]); % x is column vector
      newx(newx<a) = a(newx<a);        % reset boundary
      newx(newx>b) = b(newx>b);        % reset boundary
      newy = f(newx);
      dominates = mosd_dominates(newy, y);
      %% printvector('alpha, lambda, y, dominates: ', [alpha; lambda; newy; dominates])
      lambda = lambda + 0.1;
    end
    alpha /= 2;
    k = k + 1;
  end
  if ! dominates
    point = [x;y;0];
  else
    point = [newx;newy;0];
    mosd_numberimproved = mosd_numberimproved + 1;
  end
end
