function pop = strawberry_sort (pop,nx,nz)
  [n m] = size(pop);
  %% sorting only makes sense in single criterion problems
  if nz == 1                    % single objective optimisation
    if n-nx == 2                % y + constraint violation
                                % find feasible and infeasible sets
      feasible = pop(:, pop(n,:) <= 0);
      [s, i] = sort(feasible(nx+1,:)); % sort on objective function value
      feasible = feasible(:,i);        % sorted
      %% now check for infeasible solutions
      nfeasible = size(feasible,2);
      if nfeasible < size(pop,2)
        infeasible = pop(:, pop(n,:) > 0);
        [s, i] = sort(infeasible(n,:));
        infeasible = infeasible(:,i);
        pop = [feasible, infeasible];
      else
        pop = feasible;
      end
    else
      error('Number of objective functions does not seem to match');
    end
  end
end
